precision highp float;
varying vec2 uv0;
varying vec2 uv1;

uniform sampler2D inputImageTexture;
uniform sampler2D maskImageTexture;
uniform sampler2D lutImageTexture;

uniform float _intensity;
uniform float _uniAlpha;
uniform float openMouth;

//添加唇彩颜色
vec4 addLipColor(vec4 textureColor)
{
    float blueColor = textureColor.b * 15.0;
    vec2 quad1;
    quad1.y = max(min(4.0,floor(floor(blueColor) * 0.25)),0.0);
    quad1.x = max(min(4.0,floor(blueColor) - (quad1.y * 4.0)),0.0);

    vec2 quad2;
    quad2.y = max(min(floor(ceil(blueColor) * 0.25),4.0),0.0);
    quad2.x = max(min(ceil(blueColor) - (quad2.y * 4.0),4.0),0.0);

    vec2 texPos1;
    texPos1.x = (quad1.x * 0.25) + 0.0078125 + ((0.234375) * textureColor.r);
    texPos1.y = (quad1.y * 0.25) + 0.0078125 + ((0.234375) * textureColor.g);
    texPos1.y = 1.0 - texPos1.y;
    vec2 texPos2;
    texPos2.x = (quad2.x * 0.25) + 0.0078125 + ((0.234375) * textureColor.r);
    texPos2.y = (quad2.y * 0.25) + 0.0078125 + ((0.234375) * textureColor.g);
    texPos2.y = 1.0 - texPos2.y;
    vec4 newColor1 = texture2D(lutImageTexture, texPos1);
    vec4 newColor2 = texture2D(lutImageTexture, texPos2);

    vec4 newColor = mix(newColor1, newColor2, fract(blueColor));
    return newColor;
}

void main()
{
    vec4 src = texture2D(inputImageTexture, uv0);
    vec4 mask = texture2D(maskImageTexture, uv1);
    float alpha = (openMouth > 0.5) ? mask.g : mask.r;      // close, open, teeth
    vec4 tem = addLipColor(src);
    if(mask.a > 0.0){
        gl_FragColor = mix(src, tem, alpha * _intensity);
    }
    else{
        discard;
    }
}
