precision highp float;
varying vec2 uv0;
#define sucaiTexCoord uv0
uniform sampler2D maskImageTexture;

varying vec2 uv1;
#define textureCoordinate uv1
uniform sampler2D inputImageTexture;

//uniform sampler2D lipsLutImageTexture;
uniform sampler2D teethLutImageTexture;

uniform sampler2D sucaiImageTexture;

uniform float enableWhitenTeeth;
uniform float openMouth;
uniform float _intensity;

uniform float _uniAlpha;

#define blendModel(a,b) multiply(a,b)
vec3 multiply(vec3 base, vec3 blend) {
     return base*blend;
}

// 可以给外边改变 
const float teethDegree = 0.4;
 
vec4 lut(sampler2D lutTexture, vec4 textureColor) 
{ 
     float blueColor = textureColor.b * 15.0; 
     vec2 quad1; 
     quad1.y = max(min(4.0,floor(floor(blueColor) * 0.25)),0.0); 
     quad1.x = max(min(4.0,floor(blueColor) - (quad1.y * 4.0)),0.0); 
 
     vec2 quad2; 
     quad2.y = max(min(floor(ceil(blueColor) * 0.25),4.0),0.0); 
     quad2.x = max(min(ceil(blueColor) - (quad2.y * 4.0),4.0),0.0); 
 
     vec2 texPos1; 
     texPos1.x = (quad1.x * 0.25) + 0.0078125 + ((0.234375) * textureColor.r); 
     texPos1.y = (quad1.y * 0.25) + 0.0078125 + ((0.234375) * textureColor.g); 
     texPos1.y = 1.0 - texPos1.y;
 
     vec2 texPos2; 
     texPos2.x = (quad2.x * 0.25) + 0.0078125 + ((0.234375) * textureColor.r); 
     texPos2.y = (quad2.y * 0.25) + 0.0078125 + ((0.234375) * textureColor.g);
     texPos2.y = 1.0 - texPos2.y;
 
     vec4 newColor1 = texture2D(lutTexture, texPos1); 
     vec4 newColor2 = texture2D(lutTexture, texPos2); 
 
     vec4 newColor = mix(newColor1, newColor2, fract(blueColor)); 
     return newColor; 
} 

void main()
{
    vec4 bgVal = texture2D(inputImageTexture, textureCoordinate);
    vec4 maskVal = texture2D(maskImageTexture, sucaiTexCoord);

    vec3 colorRes = bgVal.rgb;
    if (openMouth > 0.0 && enableWhitenTeeth > 0.0) { 
        float teethAlpha = maskVal.b;
        vec4 tem = lut(teethLutImageTexture, vec4(colorRes, 1.0));
        colorRes = mix(colorRes, tem.rgb, teethAlpha * teethDegree * _intensity * _uniAlpha);
    } 

    vec4 meVal = texture2D(sucaiImageTexture, sucaiTexCoord);
    
    if(meVal.a > 0.0)
        meVal.rgb = clamp(meVal.rgb/meVal.a, 0., 1.);
    
    vec3 color = blendModel(colorRes, meVal.rgb);
    float alpha = meVal.a * _intensity * _uniAlpha;

    if (alpha > 0.0) {
        gl_FragColor = vec4(mix(colorRes, color, alpha), 1.0);
    } else {
        discard;
    }
}
